unit app_util;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, log_unit;

type

  { TEnv }

  TEnv = class
  public
    constructor Create;
    class procedure Startup;
  private
    fPath: string;
    fLogManager: TLogManager;
    procedure clear;
    procedure startupMe;
    procedure setPath(const aValue: string);
    procedure setLogManager(const aValue: TLogManager);
  public
    property path: string read fPath write setPath;
    property logManager: TLogManager read fLogManager write setLogManager;
    class function globalEnv: TEnv;
  end;

  EEnv = class(Exception);

implementation

var
  env: TEnv;

{ TEnv }

constructor TEnv.Create;
begin
  inherited Create;
  clear;
  startupMe;
end;

class procedure TEnv.Startup;
begin
  env:=TEnv.Create;
end;

procedure TEnv.clear;
begin
  fPath:='';
  fLogManager:=nil;
end;

procedure TEnv.startupMe;
begin
end;

procedure TEnv.setPath(const aValue: string);
begin
  if path <> '' then
    raise EEnv.Create('Environment path already assigned');
  if aValue = '' then
    raise EEnv.Create('setPath: "" argument passed');
  fPath:=aValue;
end;

procedure TEnv.setLogManager(const aValue: TLogManager);
begin
  if logManager <> nil then
    raise EEnv.Create('Can not reassign log manager');
  if aValue = nil then
    raise EEnv.Create('Can not assign nil log manager');
  fLogManager:=aValue;
  logManager.getLogClient(self).info('Global environment log manager assigned');
end;

class function TEnv.globalEnv: TEnv;
begin
  result:=env;
end;

initialization
  env:=nil;
finalization
  env.Free;
end.

