unit primitive_container;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,
  textable_face;

type

  generic IPrimitiveContainer<T> = interface(ITextable)
    function getValue: T;
    procedure setValue(const aValue: T);
    property value: T read getValue write setValue;
  end;

  { TPrimitiveContainer }

  generic TPrimitiveContainer<T> = class(TInterfacedObject)
    constructor Create(const aValue: T);
  protected
    fValue: T;
    function getValue: T; inline;
    procedure setValue(const aValue: T); inline;
  public
    property value: T read getValue write setValue;
    property v: T read fValue write fValue;
  end;

implementation

{ TPrimitiveContainer }

constructor TPrimitiveContainer.Create(const aValue: T);
begin
  value:=aValue;
end;

function TPrimitiveContainer.getValue: T;
begin
  result:=fValue;
end;

procedure TPrimitiveContainer.setValue(const aValue: T);
begin
  if fValue = aValue then exit;
  fValue:=aValue;
end;

end.

