program log_demo_project;

{$mode objfpc}{$H+}

uses
  Classes, log_unit, log_appenders;

{$R *.res}

type

  { TMy }

  TMy = class
    constructor Create;
  private
    log: ILogClient;
  public
    procedure test;
    destructor Destroy; override;
  end;

var
  logman: TLogManager;

{ TMy }

constructor TMy.Create;
begin
  inherited Create;
  log:=logman.getLogClient(self);
end;

procedure TMy.test;
begin
  log.fatal('Fatal error');
  log.error('Error');
  log.info('Info');
  log.debug('Debug');
  log.trace('Trace');
  log.m(66, 'Custom');
end;

destructor TMy.Destroy;
begin
  log.info('Destroyed.');
  inherited Destroy;
end;

type

  { TMyAppender }

  TMyAppender = class(TLogAppender, ILogAppender)
    function appendMessage(const aMessage: PLogMessage): boolean;
  end;

{ TMyAppender }

function TMyAppender.appendMessage(const aMessage: PLogMessage): boolean;
begin
  if aMessage^.kind <= TLog.error then
    WriteLN('  [Application panic]');
end;

var
  my: TMy;

begin
  logman:=TLogManager.Create(nil);
  logman.addAppender(TWritelnLogAppender);
  logman.addAppender(TFileLogAppender.Create('log.text'));
  logman.addAppender(TMyAppender);
  my:=TMy.Create;
  my.test;
  my.Free;
  logman.getLogClient(nil).info('Bye.');
  logman.Free;
end.

