unit intstring_map;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

type

  TIntstringMapItem = object
    x: integer;
    s: string;
  end;

  { TIntstringMap }

  TIntstringMap = class(TComponent)
  public
    constructor Create(aOwner: TComponent); override;
  private
    fList: TList;
    procedure startup;
    function getItem(const ax: integer): string;
    procedure setItem(const ax: integer; const aText: string);
    procedure freeItems;
  public
    property rawlist: TList read fList;
    function itemExists(const ax: integer): boolean;
    property items[const ax: integer]: string
      read getItem write setItem; default;
    destructor Destroy; override;
  end;

implementation

type
  TIntstring = TIntstringMapItem;
  PIntstring = ^TIntstring;

{ TIntstringMap }

constructor TIntstringMap.Create(aOwner: TComponent);
begin
  inherited Create(aOwner);
  startup;
end;

procedure TIntstringMap.startup;
begin
  fList:=TList.Create;
end;

function TIntstringMap.getItem(const ax: integer): string;
var
  p: pointer;
  item: PIntstring;
begin
  result:='';
  for p in rawlist do
  begin
    item:=PIntstring(p);
    if item^.x = ax then exit(item^.s);
  end;
end;

procedure TIntstringMap.setItem(const ax: integer; const aText: string);
var
  p: pointer;
  item: PIntstring;
begin
  for p in rawlist do
  begin
    item:=PIntstring(p);
    if item^.x = ax then
    begin
      item^.s:=aText;
      exit;
    end;
  end;

  //item not found SECTION
  item:=new(PIntstring);
  item^.x:=ax;
  item^.s:=aText;
  rawlist.Add(item);
end;

procedure TIntstringMap.freeItems;
var
  p: pointer;
  item: PIntstring;
begin
  for p in rawlist do
  begin
    item:=PIntstring(p);
    dispose(item);
  end;
  FreeAndNil(fList);
end;


function TIntstringMap.itemExists(const ax: integer): boolean;
var
  p: pointer;
  item: PIntstring;
begin
  result:=false;
  for p in rawlist do
  begin
    item:=PIntstring(p);
    if item^.x = ax then exit(true);
  end;
end;

destructor TIntstringMap.Destroy;
begin
  freeItems;
  inherited Destroy;
end;

end.

